#ifndef TUPLE_H
#define TUPLE_H

template<unsigned int n, class Type = float>
class Tuple
{
protected:
	Type Element[n];

public:
	Tuple();
	Tuple(Type e[n]);

	Tuple &operator=(const Tuple &T);

	float &operator[](int i);
	float &operator()(int i);

	const float &operator[](int i) const;
	const float &operator()(int i) const;
};

template<unsigned int n, class Type>
inline Tuple<n, Type>::Tuple()
{
}

template<unsigned int n, class Type>
inline Tuple<n, Type>::Tuple(Type e[n])
{
	for(int i = 0; i < n; i++)
		Element[i] = e[i];
}

template<unsigned int n, class Type>
inline Tuple<n, Type> &Tuple<n, Type>::operator=(const Tuple<n, Type> &T)
{
	for(int i = 0; i < n; i++)
		Element[i] = T.Element[i];

	return *this;
}

template<unsigned int n, class Type>
inline float &Tuple<n, Type>::operator[](int i)
{
	return Element[i];
}

template<unsigned int n, class Type>
inline float &Tuple<n, Type>::operator()(int i)
{
	return Element[(i - 1) & 3];	
}

template<unsigned int n, class Type>
inline const float &Tuple<n, Type>::operator[](int i) const
{
	return Element[i];
}

template<unsigned int n, class Type>
inline const float &Tuple<n, Type>::operator()(int i) const
{
	return Element[(i - 1) & 3];	
}

#endif   // TUPLE_H